import { next as am } from "@automerge/automerge";
export default function (field, update, transactions, state) {
    const { lastHeads, path } = state.field(field);
    // We don't want to call `automerge.updateAt` if there are no changes.
    // Otherwise later on `automerge.diff` will return empty patches that result in a no-op but still mess up the selection.
    let hasChanges = false;
    for (const tr of transactions) {
        if (!tr.changes.empty) {
            tr.changes.iterChanges(() => {
                hasChanges = true;
            });
        }
    }
    if (!hasChanges) {
        return undefined;
    }
    const newHeads = update(lastHeads, (doc) => {
        for (const tr of transactions) {
            tr.changes.iterChanges((fromA, toA, _fromB, _toB, inserted) => {
                am.splice(doc, path, fromA, toA - fromA, inserted.toString());
            });
        }
    });
    return newHeads;
}
//# sourceMappingURL=codeMirrorToAm.js.map