import { EditorState, StateEffect, StateField, Transaction, TransactionSpec } from "@codemirror/state";
import { Doc, Heads, Prop } from "@automerge/automerge";
export type Value = {
    lastHeads: Heads;
    path: Prop[];
    unreconciledTransactions: Transaction[];
};
type UpdateHeads = {
    newHeads: Heads;
};
export declare const effectType: import("@codemirror/state").StateEffectType<UpdateHeads>;
export declare function updateHeads(newHeads: Heads): StateEffect<UpdateHeads>;
export declare function getLastHeads(state: EditorState, field: Field): Heads;
export declare function getPath(state: EditorState, field: Field): Prop[];
export type Field = StateField<Value>;
export declare function plugin<T>(doc: Doc<T>, path: Prop[]): StateField<Value>;
export declare const reconcileAnnotationType: import("@codemirror/state").AnnotationType<unknown>;
export declare function isReconcileTx(tr: Transaction): boolean;
export declare function makeReconcile(tr: TransactionSpec): void;
export {};
